#!/bin/sh
synobra=git
synocom=ef00e58c65808c26f4c9f1c3aa45640d7c99bf56
#synocom=733c7943173143e29005c44b4fceb64302dd3098


doclean() {
  synolva=$1
  echo linux-${synobra}-${synolva}
  if [ ! -e patches-${synobra}-${synolva} ]; then
    cd linux-${synobra}-${synolva}
    #git log
    git format-patch $synocom
    mkdir ../patches-${synobra}-${synolva}
    mv ????-*.patch ../patches-${synobra}-${synolva}/
    cd ..
    rm -rf linux-${synobra}-${synolva}/
  else
    echo "...skipped"
  fi
}

#if false; then
#doclean 3776
ls -d linux-${synobra}-* | while read d ; do
  v=`echo $d | cut -d '-' -f 3-`
  cd $d
  #git checkout dsx14j-3.2.y-comcerto2k
  tag=`git tag --list '3.2.11-2636-x64' || true`
  cd ..
  if [ "X$tag" = "X" ]; then
    synocom=ef00e58c65808c26f4c9f1c3aa45640d7c99bf56
  else
    synocom=733c7943173143e29005c44b4fceb64302dd3098
  fi
  doclean $v
done
#fi

if false ; then
synobra=dsx14j
ls -d linux-dsx14j-3.2.y?* | while read d ; do
  v=`echo $d | cut -d '-' -f 3-`
  if ! echo X$v | grep -q -E '\-test$' ; then
  if [ "$v" != "3.2.yu" -a "$v" != "3.2.yw" ] ; then
  cd $d
  #git checkout dsx14j-3.2.y-comcerto2k
  tag=`git tag --list '3.2.11-2636-x64' || true`
  cd ..
  if [ "X$tag" = "X" ]; then
    synocom=ef00e58c65808c26f4c9f1c3aa45640d7c99bf56
  else
    synocom=733c7943173143e29005c44b4fceb64302dd3098
  fi
  #if [ "X$tag" = "X" ]; then
    #echo $v
    cd $d
    rc=1
    tag=`git tag --list '3.2.40-3776-armada370' || true`
    zag=`git tag --list '3.2.40-25426-comcerto2k' || true`
    if [ "X$tag" != "X" -a "X$zag" != "X" ]; then
      #echo $v
      git checkout dsx14j-3.2.y-comcerto2k > /dev/null 2>&1
      rc=$?
      #echo $rc
    fi
    cd ..
    if [ $rc = 0 ]; then
      echo ""
      echo $v
      doclean $v
    fi
  #fi
  fi
  fi
done
fi

echo OK
