#!bin/sh

if [ ! -e linux-dsx14j-3.2.y -a ! -e linux-dsx14j-3.2.30-unpatched ]; then
  git clone -b mainline-3.2 https://github.com/scpcom/linux linux-dsx14j-3.2.y

  cd linux-dsx14j-3.2.y
  git fetch
  git pull origin
  git checkout mainline-3.2
  # Linux 3.2.40
  #git checkout 733c7943173143e29005c44b4fceb64302dd3098
  # Linux 3.2.30
  git checkout ef00e58c65808c26f4c9f1c3aa45640d7c99bf56
  cd ..

  mv linux-dsx14j-3.2.y linux-dsx14j-3.2.30-unpatched
  #mkdir linux-dsx14j-3.2.30-unpatched
  #cp -apP linux-dsx14j-3.2.y/. linux-dsx14j-3.2.30-unpatched/
fi

if [ ! -e linux-dsx14j-3.2.y -a ! -e linux-dsx14j-3.2.11-unpatched ]; then
  git clone -b mainline-3.2 https://github.com/scpcom/linux linux-dsx14j-3.2.y

  cd linux-dsx14j-3.2.y
  git fetch
  git pull origin
  git checkout mainline-3.2
  # Linux 3.2.40
  #git checkout 733c7943173143e29005c44b4fceb64302dd3098
  # Linux 3.2.30
  #git checkout ef00e58c65808c26f4c9f1c3aa45640d7c99bf56
  # Linux 3.2.11
  git checkout 3f4b3b20f4b449feec8309569a65d0460d6b3f62
  cd ..

  mv linux-dsx14j-3.2.y linux-dsx14j-3.2.11-unpatched
  #mkdir linux-dsx14j-3.2.11-unpatched
  #cp -apP linux-dsx14j-3.2.y/. linux-dsx14j-3.2.11-unpatched/
fi

if [ ! -e linux-dsx14j-3.2.y ]; then
  echo "Copying linux-dsx14j-3.2.11-unpatched ..."
  mkdir linux-dsx14j-3.2.y
  cp -apP linux-dsx14j-3.2.11-unpatched/. linux-dsx14j-3.2.y/
  #cp -apP linux-dsx14j-3.2.30-unpatched/. linux-dsx14j-3.2.y/

  cd linux-dsx14j-3.2.y

  git checkout 733c7943173143e29005c44b4fceb64302dd3098
  git checkout -b mainline-3.2.40
  git checkout ef00e58c65808c26f4c9f1c3aa45640d7c99bf56
  git checkout -b mainline-3.2.30
  git checkout 3f4b3b20f4b449feec8309569a65d0460d6b3f62
  git checkout -b mainline-3.2.11

  git checkout -b dsx14j-3.2.y-comcerto2k


  #git apply ../patches/linux-3.2.11-x64-mainline-to-2636-v2-wbB.patch
  patch -p1 < ../patches/linux-3.2.11-x64-mainline-to-2636-v2-wbB.patch
  git add .
  git commit -m "mainline-to-2636: changes"

  git apply ../patches/linux-3.2.11-x64-mainline-to-2636-v2-whitespace-v2.patch
  patch -p1 < ../patches/linux-3.2.11-x64-mainline-to-2636-v2-whitespace-merge.patch
  patch -p1 < ../patches/linux-3.2.11-x64-mainline-to-2636-restore-whitespace.patch
  patch -p1 -R < ../patches/linux-3.2.11-x64-mainline-to-2636-v2-whitespace-hw_breakpoint.patch
  patch -p1 -R < ../patches/linux-3.2.11-x64-mainline-to-2636-v2-whitespace-dm-crypt.patch
  patch -p1 -R < ../patches/linux-3.2.11-x64-mainline-to-2636-v2-whitespace-bond_main.patch
  patch -p1 -R < ../patches/linux-3.2.11-x64-mainline-to-2636-v2-whitespace-usbnet.patch
  patch -p1 -R < ../patches/linux-3.2.11-x64-mainline-to-2636-v2-whitespace-cdc-wdm.patch
  patch -p1 -R < ../patches/linux-3.2.11-x64-mainline-to-2636-v2-whitespace-objio_osd.patch
  patch -p1 -R < ../patches/linux-3.2.11-x64-mainline-to-2636-v2-whitespace-nfs4proc.patch
  patch -p1 -R < ../patches/linux-3.2.11-x64-mainline-to-2636-v2-whitespace-irq-chip.patch
  patch -p1 -R < ../patches/linux-3.2.11-x64-mainline-to-2636-v2-whitespace-mm-filemap.patch
  patch -p1 -R < ../patches/linux-3.2.11-x64-mainline-to-2636-v2-whitespace-tcp_ipv4.patch
  patch -p1 -R < ../patches/linux-3.2.11-x64-mainline-to-2636-v2-whitespace-ip6_output.patch
  git add .
  git commit -m "mainline-to-2636: add whitespaces"

  git apply ../patches/linux-3.2.11-x64-mainline-to-2636-extra-v2.patch
  git apply ../patches/linux-3.2.11-x64-mainline-to-2636-extra-v2-gitignore.patch
  git add .
  git commit -m "mainline-to-2636: add/remove files"

  git tag -a 3.2.11-2636-x64 -m "dsgpl 2636 branch x64"


  git merge -s recursive -X ours -X renormalize -X no-renames mainline-3.2.30 | tee ../merge-30.log

  #git apply ../patches/linux-3.2.40-armada370-merged-2636-to-3201-fix-merge.patch
  git apply ../patches/linux-3.2.40-armada370-merged-2636-to-3201-fix-merge-v3.patch
  git add .
  git commit -m "2636-to-3201: fix merge"

  #patch -p1 -R < ../patches/linux-3.2.40-armada370-merged-2636-to-3201-fix-merge.patch
  #git apply ../patches/linux-3.2.40-armada370-2636-to-3201.patch
  #git apply ../patches/linux-3.2.40-armada370-merged-2636-to-3201.patch
  git apply ../patches/linux-3.2.40-armada370-merged-2636-to-3201-v3.patch
  git add .
  git commit -m "2636-to-3201: changes"

  #git apply ../patches/linux-3.2.40-armada370-2636-to-3201-extra.patch
  git apply ../patches/linux-3.2.40-armada370-merged-2636-to-3201-extra.patch
  git add .
  git commit -m "2636-to-3201: add/remove files"

  patch -p1 -R < ../patches/linux-3.2.40-armada370-merged-2636-to-3201-restore-whitespace.patch
  patch -p1 < ../patches/linux-3.2.40-armada370-merged-2636-to-3201-v2-whitespace-merge.patch
  git add .
  git commit -m "2636-to-3201: add whitespaces"

  VERSION=`cat Makefile | grep -E '^VERSION.=' | cut -d "=" -f 2- | tr -d " \t\n\r"`
  PATCHLEVEL=`cat Makefile | grep PATCHLEVEL.= | cut -d "=" -f 2- | tr -d " \t\n\r"`
  SUBVERSION=`cat Makefile | grep SUBLEVEL.= | cut -d "=" -f 2- | tr -d " \t\n\r"`

  git tag -a 3.2.30-3201-x64 -m "dsgpl 3201 branch x64"
  #git tag


  git apply ../patches/linux-3.2.40-armada370-3201-to-3203.patch
  git add .
  git commit -m "3201-to-3203: changes"

  git tag -a 3.2.30-3203-armada370 -m "dsgpl 3203 branch armada370"


  #if false ; then
  git merge -s recursive -X ours -X renormalize -X no-renames mainline-3.2.40 | tee ../merge-40.log

  #git apply ../patches/linux-3.2.40-armada370-merged-3203-to-3776-fix-merge.patch
  #git apply ../patches/linux-3.2.40-armada370-merged-3203-to-3776-fix-merge-v3.patch
  git apply ../patches/linux-3.2.40-armada370-merged-3203-to-3776-fix-merge-v4.patch
  git add .
  git commit -m "3203-to-3776: fix merge"

  #patch --no-backup-if-mismatch -p1 -R < ../patches/linux-3.2.40-armada370-merged-3203-to-3776-fix-merge.patch
  #patch -p1 < ../patches/linux-3.2.40-armada370-merged-3203-to-3776-fix-merge-w.patch
  ##git apply ../patches/linux-3.2.40-armada370-3203-to-3776.patch
  #git apply ../patches/linux-3.2.40-armada370-merged-3203-to-3776.patch
  git apply ../patches/linux-3.2.40-armada370-merged-3203-to-3776-v3.patch
  git add .
  git commit -m "3203-to-3776: changes"
  
  #git apply ../patches/linux-3.2.40-armada370-3203-to-3776-extra.patch
  git apply ../patches/linux-3.2.40-armada370-merged-3203-to-3776-extra.patch
  git add .
  git commit -m "3203-to-3776: add/remove files"
 
  git apply ../patches/linux-3.2.40-armada370-merged-3203-to-3776-whitespace-a.patch
  git apply ../patches/linux-3.2.40-armada370-merged-3203-to-3776-whitespace-c.patch
  git apply ../patches/linux-3.2.40-armada370-merged-3203-to-3776-whitespace-d.patch
  git apply ../patches/linux-3.2.40-armada370-merged-3203-to-3776-whitespace-b.patch
  git apply ../patches/linux-3.2.40-armada370-merged-3203-to-3776-whitespace-e.patch
  git add .
  git commit -m "3203-to-3776: add whitespaces"

  VERSION=`cat Makefile | grep -E '^VERSION.=' | cut -d "=" -f 2- | tr -d " \t\n\r"`
  PATCHLEVEL=`cat Makefile | grep PATCHLEVEL.= | cut -d "=" -f 2- | tr -d " \t\n\r"`
  SUBVERSION=`cat Makefile | grep SUBLEVEL.= | cut -d "=" -f 2- | tr -d " \t\n\r"`
  
  git tag -a ${VERSION}.${PATCHLEVEL}.${SUBVERSION}-3776-armada370 -m "dsgpl 3776 branch armada370"
  
  
  #git apply ../patches/linux-3.2.40-armada370-merged-3203-to-3776-whitespace-a.patch
  git apply ../patches/linux-3.2.11-x64-mainline-to-2636-v2-whitespace-ip6_output-part1.patch
  git apply ../patches/linux-3.2.40-armada370-3776-to-4418.patch
  git add .
  git commit -m "3776-to-4418: changes"
  
  grep -E '^\+\+\+.*/\.gitignore' ../patches/linux-3.2.40-armada370-3776-to-4418-extra.patch | cut -d / -f 2- | cut -f 1 | while read f ; do
    if [ -e $f ]; then
      rm $f
    fi
  done
  
  git apply ../patches/linux-3.2.40-armada370-3776-to-4418-extra.patch
  git add .
  git commit -m "3776-to-4418: add/remove files"
  
  VERSION=`cat Makefile | grep -E '^VERSION.=' | cut -d "=" -f 2- | tr -d " \t\n\r"`
  PATCHLEVEL=`cat Makefile | grep PATCHLEVEL.= | cut -d "=" -f 2- | tr -d " \t\n\r"`
  SUBVERSION=`cat Makefile | grep SUBLEVEL.= | cut -d "=" -f 2- | tr -d " \t\n\r"`
  
  git tag -a ${VERSION}.${PATCHLEVEL}.${SUBVERSION}-4418-armada370 -m "dsgpl 4418 branch armada370"
  
  
  git apply ../patches/linux-3.2.40-comcerto2k-4418-to-4458.patch
  git add .
  git commit -m "4418-to-4458: changes"
  
  #grep -E '^\+\+\+.*/\.gitignore' ../patches/linux-3.2.40-comcerto2k-4418-to-4458-extra.patch | cut -d / -f 2- | cut -f 1 | while read f ; do
  #  if [ -e $f ]; then
  #    rm $f
  #  fi
  #done
  
  git apply ../patches/linux-3.2.40-comcerto2k-4418-to-4458-extra.patch
  git add .
  git commit -m "4418-to-4458: add/remove files"
  
  git tag -a ${VERSION}.${PATCHLEVEL}.${SUBVERSION}-4458-comcerto2k -m "dsgpl 4458 branch comcerto2k"
  

  #git apply ../patches/linux-3.2.40-comcerto2k-5004-restore-defs.patch  
  git apply ../patches/linux-3.2.40-comcerto2k-5004-restore-defs-v2.patch
  git apply ../patches/linux-3.2.40-comcerto2k-5004-restore-defs-SYNO_RAID_STATUS_DISKERROR-v2.patch
  git add .
  git commit -m "4458-to-5004: restore defines"

  #git apply ../patches/linux-3.2.40-armada370-merged-3203-to-3776-whitespace-c.patch
  git apply ../patches/linux-3.2.11-x64-mainline-to-2636-v2-whitespace-ip6_output-part3.patch
  git apply ../patches/linux-3.2.40-comcerto2k-4458-to-5004.patch
  git add .
  git commit -m "4458-to-5004: changes"
  
  git apply ../patches/linux-3.2.40-comcerto2k-4458-to-5004-extra.patch
  git add .
  git commit -m "4458-to-5004: add/remove files"
  
  git tag -a 3.2.40-5004-comcerto2k -m "dsgpl 5004 branch comcerto2k"
  
  
  #git apply ../patches/linux-3.2.40-comcerto2k-5004-to-5510-extra-whitespace.patch
  #git apply ../patches/linux-3.2.40-armada370-merged-3203-to-3776-whitespace-d.patch
  git apply ../patches/linux-3.2.40-comcerto2k-5004-to-5510.patch
  git add .
  git commit -m "5004-to-5510: changes"
  
  git apply ../patches/linux-3.2.40-comcerto2k-5004-to-5510-extra.patch
  git add .
  git commit -m "5004-to-5510: add/remove files"
  
  #git apply ../patches/linux-3.2.40-comcerto2k-5510-remove-defs.patch
  #git apply ../patches/linux-3.2.40-comcerto2k-5510-remove-defs-whitespaces-v2.patch
  #git apply ../patches/linux-3.2.40-comcerto2k-5510-remove-defs-v2.patch
  ##git apply ../patches/linux-3.2.40-comcerto2k-5510-remove-defs-extra.patch
  #git apply ../patches/linux-3.2.40-comcerto2k-5510-remove-defs-extra-v2.patch
  git apply ../patches/linux-3.2.40-comcerto2k-5510-remove-defs-SYNO_RAID_STATUS_DISKERROR-v2.patch
  git apply ../patches/linux-3.2.40-comcerto2k-5510-remove-defs-v2-whitespaces.patch
  git apply ../patches/linux-3.2.40-comcerto2k-5510-remove-defs-v2.patch
  git add .
  git commit -m "5004-to-5510: remove defines"

  git tag -a 3.2.40-5510-comcerto2k -m "dsgpl 5510 branch comcerto2k"
  
  
  git apply ../patches/linux-3.2.40-comcerto2k-5510-to-5565.patch
  git add .
  git commit -m "5510-to-5565: changes"
  
  git apply ../patches/linux-3.2.40-comcerto2k-5510-to-5565-extra.patch
  git add .
  git commit -m "5510-to-5565: add/remove files"
  
  git tag -a 3.2.40-5565-comcerto2k -m "dsgpl 5565 branch comcerto2k"
  
  
  git apply ../patches/linux-3.2.40-comcerto2k-5565-to-7321.patch
  git add .
  git commit -m "5565-to-7321: changes"
  
  git apply ../patches/linux-3.2.40-comcerto2k-5565-to-7321-extra.patch
  chmod ugo+rx syno_check_env.sh
  git add .
  git commit -m "5565-to-7321: add/remove files"

  #echo OK
  #exit 0

  git tag -a 3.2.40-7321-comcerto2k -m "dsgpl 7321 branch comcerto2k"

  #git apply ../patches/linux-3.2.40-armada370-merged-3203-to-3776-whitespace-b.patch
  git apply ../patches/linux-3.2.11-x64-mainline-to-2636-v2-whitespace-dm-crypt-part1.patch
  git apply ../patches/linux-3.2.11-x64-mainline-to-2636-v2-whitespace-tcp_ipv4-part1.patch
  git apply ../patches/linux-3.2.40-comcerto2k-8451-remove-comments-wbB.patch
  git apply ../patches/linux-3.2.40-comcerto2k-8451-remove-comments-extra-whitespace.patch
  git add .
  git commit -m "7321-to-8451: remove comments"

  #needsynobios=0
  #cp -p include/linux/synobios.h include/linux/synobios.h-7321
  
  #git apply ../patches/linux-3.2.40-comcerto2k-7321-to-8451-extra-whitespace.patch
  git apply ../patches/linux-3.2.40-comcerto2k-7321-to-8451.patch
  git add .
  git commit -m "7321-to-8451: changes"
  
  needsynobios=0
  cp -p include/linux/synobios.h include/linux/synobios.h-7321
  git apply ../patches/linux-3.2.40-comcerto2k-7321-to-8451-extra.patch
  if [ ! -e include/linux/synobios.h ]; then
    needsynobios=1
    cp -p include/linux/synobios.h-7321 include/linux/synobios.h
  fi
  rm include/linux/synobios.h-7321
  git add .
  git commit -m "7321-to-8451: add/remove files"

  needsynobios=1
  git apply ../patches/linux-3.2.40-comcerto2k-8451-remove-defs.patch
  git add .
  git commit -m "7321-to-8451: remove defines"

  git tag -a 3.2.40-8451-comcerto2k -m "dsgpl 8451 branch comcerto2k"
  
  
  git apply ../patches/linux-3.2.40-comcerto2k-8451-to-15047.patch
  git apply ../patches/linux-3.2.40-comcerto2k-8451-to-15047-synobios.patch
  git add .
  git commit -m "8451-to-15047: changes"
  
  if [ $needsynobios = 1 ]; then
    rm include/linux/synobios.h
  fi
  git apply ../patches/linux-3.2.40-comcerto2k-8451-to-15047-extra.patch
  git add .
  git commit -m "8451-to-15047: add/remove files"
  
  git tag -a 3.2.40-15047-comcerto2k -m "dsgpl 15047 branch comcerto2k"
  
  
  git apply ../patches/linux-3.2.40-comcerto2k-15047-to-15152.patch
  git add .
  git commit -m "15047-to-15152: changes"
  
  git apply ../patches/linux-3.2.40-comcerto2k-15047-to-15152-extra.patch
  git add .
  git commit -m "15047-to-15152: add/remove files"
  
  git tag -a 3.2.40-15152-comcerto2k -m "dsgpl 15152 branch comcerto2k"
  
  
  git apply ../patches/linux-3.2.40-comcerto2k-15152-to-22259.patch
  git add .
  git commit -m "15152-to-22259: changes"
  
  #git apply ../patches/linux-3.2.40-comcerto2k-15152-to-22259-extra.patch
  #git add .
  #git commit -m "15152-to-22259: add/remove files"
  #fi
  
  git tag -a 3.2.40-22259-comcerto2k -m "dsgpl 22259 branch comcerto2k"
  
  
  #git apply ../patches/linux-3.2.40-armada370-merged-3203-to-3776-whitespace-e.patch
  git apply ../patches/linux-3.2.40-comcerto2k-22259-to-24922.patch
  git apply ../patches/linux-3.2.40-comcerto2k-22259-to-24922-gitignore.patch
  git add .
  git commit -m "22259-to-24922: changes"
  
  git apply ../patches/linux-3.2.40-comcerto2k-22259-to-24922-extra.patch
  git add .
  git commit -m "22259-to-24922: add/remove files"
  
  git tag -a 3.2.40-24922-comcerto2k -m "dsgpl 24922 branch comcerto2k"
  
  
  git apply ../patches/linux-3.2.40-comcerto2k-24922-to-25426.patch
  git add .
  git commit -m "24922-to-25426: changes"
  
  #git apply ../patches/linux-3.2.40-comcerto2k-24922-to-25426-extra.patch
  #git add .
  #git commit -m "24922-to-25426: add/remove files"

  git apply ../patches/linux-3.2.40-comcerto2k-24922-to-25426-defs.patch
  git add .
  git commit -m "24922-to-25426: restore defines"

  git tag -a 3.2.40-25426-comcerto2k -m "dsgpl 25426 branch comcerto2k"

  cd ..
fi

echo OK
