synolxa=linux-3.2.40-4458-patched1
synolvb=15100

if [ "X$1" != "X" ]; then
  synolxa=$1
fi

synolxr=${synolxa}r

echo "Using ${synolxa}"

file=none
force=false

do_remove_comments() {
  mkdir -p `dirname $2`

  #if false; then
  #  sed 's/a/aA/g;s/__/aB/g;s/#/aC/g' "$file" |
  #        gcc -P -E $arg - |
  #        sed 's/aC/#/g;s/aB/__/g;s/aA/a/g' > $2
  #

  docp=false
  if [ ${synolvb} -lt 15000 ]; then
    docp=true
  elif echo $file | grep -E '^arch/arm/boot/.*\.S|^arch/arm/include/.*\.S|^arch/arm/kernel/.*\.S|^arch/arm/lib/.*\.S|^arch/arm/mm/.*\.S|'\
'^drivers/net/ethernet/intel/|^fs/fuse/|^Makefile|^scripts/kconfig/|^security/apparmor/' > /dev/null ; then
    docp=true
  elif echo $file | grep -E '^arch/arm/mach-armada375/headsmp.S|^arch/arm/mach-armada38x/headsmp.S|^arch/x86/ia32/ia32entry.S|^arch/x86/kernel/syscall_table_32.S' > /dev/null ; then
    docp=true
  fi

  if [ $docp = true -a $force != true ] ; then
    if [ ${synolxa} != ${synolxr} ]; then
      cp -p "$1/$file" $2
    fi
  else
    if [ ${synolxa} = ${synolxr} ]; then
      file=${file}-org
      cp -p $2 "$1/$file"
    fi
#    sed -r ':a; s%(.*)/\*.*\*/%\1%; ta; /\/\*/ !b; N; ba' "$1/$file" | x
    cat "$1/$file" | \
    sed 's|with //|with /_XCFG_/|g' | \
    sed 's|s//|s/_XCFG_/|g' | \
    sed 's|://|:/_XCFG_/|g' | \
    sed 's|=//|=/_XCFG_/|g' | \
    sed 's|"//|"/_XCFG_/|g' | \
sed 's|\*/\\n"|\*_XCFG_/\\n"|g' | \
sed 's|"/\*|"/_XCFG_*|g' | \
sed 's|\*/"|*_XCFG_/"|g' | \
sed 's|"#endif /\*|"#endif /_XCFG_*|g' | \
sed -r ':a; s%(.*)/\*.*\*/%\1%; ta; /\/\*/ !b; N; ba' | \
    sed 's|//.*||g' | \
sed 's|\*_XCFG_/\\n"|\*/\\n"|g' | \
sed 's|"/_XCFG_\*|"/*|g' | \
sed 's|\*_XCFG_/"|\*/"|g' | \
sed 's|"#endif /_XCFG_\*|"#endif /*|g' | \
    sed 's|with /_XCFG_/|with //|g' | \
    sed 's|s/_XCFG_/|s//|g' | \
    sed 's|:/_XCFG_/|://|g' | \
    sed 's|=/_XCFG_/|=//|g' | \
    sed 's|"/_XCFG_/|"//|g' > $2
    if [ ${synolxa} = ${synolxr} ]; then
      rm -f "$1/$file"
    fi
  fi
}

if [ "X$2" = "X-i" ]; then
  synolxr=${synolxa}
else
  mkdir ${synolxr}
  cp -apP ${synolxa}/. ${synolxr}/
fi

for f in `cat _defabc-files.txt` ; do
  file=$f
  if [ -e ${synolxr}/$file ]; then
    echo $f
    do_remove_comments ${synolxa} ${synolxr}/$file
  else
    echo "not found $f"
  fi
done

force=true

for f in `cat _comment-files.txt` ; do
  file=$f
  if [ -e ${synolxr}/$file ]; then
    echo $f
    do_remove_comments ${synolxa} ${synolxr}/$file
  else
    echo "not found $f"
  fi
done
