if [ ! -e linux-3.2.11-2636-v2-whitespace-patched0 ]; then
  echo "Copying linux-dsx14j-3.2.y ..."
  mkdir linux-3.2.11-2636-v2-whitespace-patched0
  cp -apP linux-dsx14j-3.2.y/. linux-3.2.11-2636-v2-whitespace-patched0/
  cd linux-3.2.11-2636-v2-whitespace-patched0/
  git checkout 3c26ec1e4ef733025776900a96c7b2e8921dd785
  cd ..
fi

if [ ! -e linux-3.2.11-2636-v2-whitespace-patched0b ]; then
  echo "Copying linux-3.2.11-2636-v2-whitespace-patched0 ..."
  mkdir linux-3.2.11-2636-v2-whitespace-patched0b
  cp -apP linux-3.2.11-2636-v2-whitespace-patched0/. linux-3.2.11-2636-v2-whitespace-patched0b/
  cd linux-3.2.11-2636-v2-whitespace-patched0b/
  git apply ../patches/linux-3.2.11-x64-mainline-to-2636-v2-whitespace.patch
  cd ..
fi

#for f in `cat _syno-files-all.txt` ; do
#for f in `cat _syno-files-mainline-to-3203.txt` ; do
for f in `cat _syno-files-2636-v2-whitespace.txt` ; do
  if ! grep -q -E "^${f}$" _syno-files.txt ; then
    if ! grep -q -E "^${f}$" _syno-files-3203.txt ; then
      if ! grep -q -E "^${f}$" _syno-files-extra.txt ; then
        if ! grep -q -E "^${f}$" _syno-files-space.txt ; then
          if ! grep -q -E "^${f}$" _syno-files-20210823.txt ; then
          echo $f
	  cp -p linux-3.2.11-2636-v2-whitespace-patched0/${f} linux-3.2.11-2636-v2-whitespace-patched0b/${f}
          fi
        fi
      fi
    fi
  fi
done

echo "Creating linux-3.2.11-x64-mainline-to-2636-v2-whitespace-v2.patch ..."
diff -ur linux-3.2.11-2636-v2-whitespace-patched0 linux-3.2.11-2636-v2-whitespace-patched0b > patches/linux-3.2.11-x64-mainline-to-2636-v2-whitespace-v2.patch || true

echo OK
